# 🧩 Laravel Vuexy Website Layout: Porto

<p align="center">
    <a href="https://koneko.mx" target="_blank">
        <img src="https://git.koneko.mx/Koneko-ST/koneko-st/raw/branch/main/logo-images/horizontal-05.png" width="400" alt="Koneko Soluciones Tecnológicas Logo">
    </a>
</p>

<p align="center">
    <a href="https://koneko.mx"><img src="https://img.shields.io/badge/Website-koneko.mx-blue" alt="Website"></a>
    <a href="https://github.com/koneko-mx/laravel-vuexy-website-layout-porto"><img src="https://img.shields.io/github/license/koneko-mx/laravel-vuexy-website-layout-porto" alt="License"></a>
    <a href="https://github.com/koneko-mx/laravel-vuexy-website-layout-porto/issues"><img src="https://img.shields.io/github/issues/koneko-mx/laravel-vuexy-website-layout-porto" alt="Issues"></a>
</p>

---

## 📌 Description

**Laravel Vuexy Website Layout: Porto** is a professional, modular website layout designed to work with the [Vuexy Website Admin](https://github.com/koneko-mx/laravel-vuexy-website-admin) module within the Koneko ERP ecosystem.

Based on the well-known **Porto HTML Template**, this package offers support for over 85 unique visual variants, including corporate websites, blogs, portfolios, product landings, and more — all integrated with Laravel Blade components and dynamic content blocks.

---

### ⚠️ Legal

This repository **does not include premium template files**. For production, you must acquire a legal license of the template through the following link:

👉 [https://themeforest.net/item/porto-responsive-html5-template/4106987](https://themeforest.net/item/porto-responsive-html5-template/4106987)

---

## 🚀 Quick Installation

```bash
composer require koneko/laravel-vuexy-website-layout-porto:dev-develop
php artisan vendor:publish --tag=vuexy-website-layout-porto-assets
```

This will publish the public assets under:

```
/public/vendor/vuexy-layout-porto/
```

---

## 📦 Features

* ⚡ Over 85 Porto-based templates ready to use
* 🧹 Blade-based components for every template
* 🎨 Template switching via Vuexy Website Admin UI
* 🖼️ Banners, widgets and dynamic sections
* 🧠 Fully compatible with Koneko CMS and multilingual content
* 📁 SCSS-ready with Vite and Blade optimization
* 🔌 Designed for performance and SEO

---

## 📁 Folder Structure Highlights

```
resources/
├── views/templates/
│   ├── accounting-1/
│   ├── digital-agency/
│   ├── real-estate/
│   ├── ...
│   └── vuexy-website-layout-porto/
│
├── views/templates/{template}/components/
├── public/
│   └── vendor/vuexy-layout-porto/
└── img/module-cover.png
```

---

## 📎 Visual Templates Included

Some of the included variants:

* Architecture & Interior Design
* Digital Agency (dark and light)
* Finance & Accounting
* Cleaning Services
* Church, Barber, Restaurant, Coffee Shop
* Construction & Renewable Energy
* Education, Wedding, Portfolio, Resume
* Product Landing, App Landing, SaaS
* SEO-focused and Event-based layouts

See the full list in the `views/templates/` directory.

---

## ⚙️ Integration with Koneko Ecosystem

This layout automatically registers itself in the **Koneko Vuexy Admin** UI as a visual module. From the admin interface, you can:

* Select the Porto layout for your site
* Configure specific banners and variants
* Activate or deactivate blocks per page
* Use multilingual variants with `hreflang` support

It is fully compatible with the `website_contents`, `website_seo_profiles`, and `website_menus` modules.

---

## 🛠️ Requirements

* PHP `^8.2`
* Laravel `^11.31`
* [koneko/laravel-vuexy-website-admin](https://github.com/koneko-mx/laravel-vuexy-website-admin)
* Node + Vite for SCSS customization (optional but recommended)

---

## 📄 License

This package is licensed under the [custom Business Source License 1.1](LICENSE), transitioning to MIT after 3 years. For commercial usage, redistribution, or extended usage, please contact:

📧 [opensource@koneko.mx](mailto:opensource@koneko.mx)

---

## 📚 More Information

* [Vuexy Website Admin Module](https://github.com/koneko-mx/laravel-vuexy-website-admin)
* [Vuexy Admin Core](https://github.com/koneko-mx/laravel-vuexy-admin)
* [Documentation in Spanish](README.md)
* [Koneko ST Official Website](https://koneko.mx)
* [Contact Email](mailto:opensource@koneko.mx)

---

<p align="center">
    Made with ❤️ in Mexico by <a href="https://koneko.mx">Koneko Soluciones Tecnológicas</a>
</p>
