<?php

declare(strict_types=1);

return [
    // 🌐 Identidad del Módulo
    'name' => 'Template Porto',
    'description' => 'Plantilla Porto para el modulo vuexy-website-admin, banners, widgets y CSS personalizado.',
    'type' => 'plugin',
    'tags' => ['koneko-official', 'plantilla', 'banners', 'porto', 'css', 'template', 'vuexy-website-admin', 'website'],

    // ⚙️ Namespace de configuraciones Koneko Vuexy Admin
    'componentNamespace' => 'website-layout-porto',

    // 🧠 Metadatos visuales para UI del gestor
    'ui' => [
        'image'  => 'resources/img/module-cover.png',
        'readme' => 'README.md',
    ],

    // 📁 Recursos cargables: vistas, traducciones, migraciones
    'views' => [
        'accounting-1'          => 'resources/views/templates/accounting-1',
        'app-landing'           => 'resources/views/templates/app-landing',
        'architecture-2'        => 'resources/views/templates/architecture-2',
        'architecture-interior' => 'resources/views/templates/architecture-interior',
        'auto-services'         => 'resources/views/templates/auto-services',
        'band'                  => 'resources/views/templates/band',
        'barber'                => 'resources/views/templates/barber',
        'beauty-salon'          => 'resources/views/templates/beauty-salon',
        'business-consulting'   => 'resources/views/templates/business-consulting',
        'business-consulting-2' => 'resources/views/templates/business-consulting-2',
        'business-consulting-3' => 'resources/views/templates/business-consulting-3',
        'business-consulting-4' => 'resources/views/templates/business-consulting-4',
        'business-consulting-5' => 'resources/views/templates/business-consulting-5',
        'church'                => 'resources/views/templates/church',
        'cleaning-services'     => 'resources/views/templates/cleaning-services',
        'coffee'                => 'resources/views/templates/coffee',
        'construction'          => 'resources/views/templates/construction',
        'construction-2'        => 'resources/views/templates/construction-2',
        'creative-agency-1'     => 'resources/views/templates/creative-agency-1',
        'creative-agency-2'     => 'resources/views/templates/creative-agency-2',
        'dentist'               => 'resources/views/templates/dentist',
        'digital-agency'        => 'resources/views/templates/digital-agency',
        'digital-agency-2'      => 'resources/views/templates/digital-agency-2',
        'digital-agency-2-dark' => 'resources/views/templates/digital-agency-2-dark',
        'education'             => 'resources/views/templates/education',
        'event'                 => 'resources/views/templates/event',
        'finance'               => 'resources/views/templates/finance',
        'gym'                   => 'resources/views/templates/gym',
        'hotel'                 => 'resources/views/templates/hotel',
        'industry-factory'      => 'resources/views/templates/industry-factory',
        'insurance'             => 'resources/views/templates/insurance',
        'it-services'           => 'resources/views/templates/it-services',
        'landing'               => 'resources/views/templates/landing',
        'law-firm'              => 'resources/views/templates/law-firm',
        'law-firm-2'            => 'resources/views/templates/law-firm-2',
        'marketing-1'           => 'resources/views/templates/marketing-1',
        'medical'               => 'resources/views/templates/medical',
        'medical-2'             => 'resources/views/templates/medical-2',
        'one-page-agency'       => 'resources/views/templates/one-page-agency',
        'personal-portfolio-1'  => 'resources/views/templates/personal-portfolio-1',
        'personal-portfolio-2'  => 'resources/views/templates/personal-portfolio-2',
        'personal-portfolio-3'  => 'resources/views/templates/personal-portfolio-3',
        'photography'           => 'resources/views/templates/photography',
        'photography-2'         => 'resources/views/templates/photography-2',
        'photography-3'         => 'resources/views/templates/photography-3',
        'product-landing'       => 'resources/views/templates/product-landing',
        'real-estate'           => 'resources/views/templates/real-estate',
        'renewable-energy'      => 'resources/views/templates/renewable-energy',
        'restaurant'            => 'resources/views/templates/restaurant',
        'resume'                => 'resources/views/templates/resume',
        'resume-dark'           => 'resources/views/templates/resume-dark',
        'sass'                  => 'resources/views/templates/sass',
        'seo'                   => 'resources/views/templates/seo',
        'seo-2'                 => 'resources/views/templates/seo-2',
        'seo-3'                 => 'resources/views/templates/seo-3',
        'startup-agency'        => 'resources/views/templates/startup-agency',
        'transportation-logistic' => 'resources/views/templates/transportation-logistic',
        'wedding'               => 'resources/views/templates/wedding',
        'vuexy-website-layout-porto' => 'resources/views/',
    ],

    'bladeComponents' => [
        'business-consulting-4' => 'resources/views/templates/business-consulting-4/components',
        'cleaning-services'     => 'resources/views/templates/cleaning-services/components',
        'renewable-energy'      => 'resources/views/templates/renewable-energy/components',
        'accounting-1'          => 'resources/views/templates/accounting-1/components',
        'app-landing'           => 'resources/views/templates/app-landing/components',
        'architecture-2'        => 'resources/views/templates/architecture-2/components',
        'architecture-interior' => 'resources/views/templates/architecture-interior/components',
        'auto-services'         => 'resources/views/templates/auto-services/components',
        'band'                  => 'resources/views/templates/band/components',
        'barber'                => 'resources/views/templates/barber/components',
        'beauty-salon'          => 'resources/views/templates/beauty-salon/components',
        'business-consulting'   => 'resources/views/templates/business-consulting/components',
        'business-consulting-2' => 'resources/views/templates/business-consulting-2/components',
        'business-consulting-3' => 'resources/views/templates/business-consulting-3/components',
        'business-consulting-4' => 'resources/views/templates/business-consulting-4/components',
        'business-consulting-5' => 'resources/views/templates/business-consulting-5/components',
        'church'                => 'resources/views/templates/church/components',
        'cleaning-services'     => 'resources/views/templates/cleaning-services/components',
        'coffee'                => 'resources/views/templates/coffee/components',
        'construction'          => 'resources/views/templates/construction/components',
        'construction-2'        => 'resources/views/templates/construction-2/components',
        'creative-agency-1'     => 'resources/views/templates/creative-agency-1/components',
        'creative-agency-2'     => 'resources/views/templates/creative-agency-2/components',
        'dentist'               => 'resources/views/templates/dentist/components',
        'digital-agency'        => 'resources/views/templates/digital-agency/components',
        'digital-agency-2'      => 'resources/views/templates/digital-agency-2/components',
        'digital-agency-2-dark' => 'resources/views/templates/digital-agency-2-dark/components',
        'education'             => 'resources/views/templates/education/components',
        'event'                 => 'resources/views/templates/event/components',
        'finance'               => 'resources/views/templates/finance/components',
        'gym'                   => 'resources/views/templates/gym/components',
        'hotel'                 => 'resources/views/templates/hotel/components',
        'industry-factory'      => 'resources/views/templates/industry-factory/components',
        'insurance'             => 'resources/views/templates/insurance/components',
        'it-services'           => 'resources/views/templates/it-services/components',
        'landing'               => 'resources/views/templates/landing/components',
        'law-firm'              => 'resources/views/templates/law-firm/components',
        'law-firm-2'            => 'resources/views/templates/law-firm-2/components',
        'marketing-1'           => 'resources/views/templates/marketing-1/components',
        'medical'               => 'resources/views/templates/medical/components',
        'medical-2'             => 'resources/views/templates/medical-2/components',
        'one-page-agency'       => 'resources/views/templates/one-page-agency/components',
        'personal-portfolio-1'  => 'resources/views/templates/personal-portfolio-1/components',
        'personal-portfolio-2'  => 'resources/views/templates/personal-portfolio-2/components',
        'personal-portfolio-3'  => 'resources/views/templates/personal-portfolio-3/components',
        'photography'           => 'resources/views/templates/photography/components',
        'photography-2'         => 'resources/views/templates/photography-2/components',
        'photography-3'         => 'resources/views/templates/photography-3/components',
        'product-landing'       => 'resources/views/templates/product-landing/components',
        'real-estate'           => 'resources/views/templates/real-estate/components',
        'renewable-energy'      => 'resources/views/templates/renewable-energy/components',
        'restaurant'            => 'resources/views/templates/restaurant/components',
        'resume'                => 'resources/views/templates/resume/components',
        'resume-dark'           => 'resources/views/templates/resume-dark/components',
        'sass'                  => 'resources/views/templates/sass/components',
        'seo'                   => 'resources/views/templates/seo/components',
        'seo-2'                 => 'resources/views/templates/seo-2/components',
        'seo-3'                 => 'resources/views/templates/seo-3/components',
        'startup-agency'        => 'resources/views/templates/startup-agency/components',
        'transportation-logistic' => 'resources/views/templates/transportation-logistic/components',
        'wedding'               => 'resources/views/templates/wedding/components',
        'vuexy-website-layout-porto' => 'resources/views/templates/Porto/components',
    ],

    // 📁 Publicar archivos
    'publishedFiles' => [
        'assets' => [
            'resources/public' => public_path('vendor/vuexy-layout-porto'),
        ],
    ],
];
